export declare type CanvasJpWeightedPoint = {
    __type: "Point";
    x: number;
    y: number;
    weight: number;
};
export declare type CanvasJpCurvePoint = {
    __type: "CurvePoint";
    x: number;
    y: number;
    prevControl: CanvasJpPoint;
    nextControl: CanvasJpPoint;
};
export declare type CanvasJpPoint = CanvasJpWeightedPoint | CanvasJpCurvePoint;
export declare const Point: (x: number, y: number, weight?: number) => CanvasJpWeightedPoint;
export declare const CurvePoint: (x: number, y: number, prevControl: CanvasJpPoint, nextControl: CanvasJpPoint) => CanvasJpCurvePoint;
export declare const isPointEqual: (pointA: CanvasJpPoint, pointB: CanvasJpPoint, epsilon?: number) => boolean;
export declare const weightPoint: (point: CanvasJpPoint, weight: number) => CanvasJpWeightedPoint;
export declare type CanvasJpPoint3D = {
    x: number;
    y: number;
    z: number;
};
export declare const Point3D: (x: number, y: number, z: number) => CanvasJpPoint3D;
