import { CanvasJpFill, CanvasJpStroke } from "./draw";
import { CanvasJpSharpLine } from "./Line";
import { CanvasJpPoint, CanvasJpWeightedPoint } from "./Point";
import { CanvasJpSharpShape } from "./Shape";
export declare type CanvasJpPolygon = {
    __type: "Polygon";
    points: CanvasJpPoint[];
    toShape: (fill?: CanvasJpFill, stroke?: CanvasJpStroke) => CanvasJpSharpShape;
};
export declare const Polygon: (points: CanvasJpPoint[]) => CanvasJpPolygon;
export declare const PolygonFromRect: (x: number, y: number, width: number, height: number) => CanvasJpPolygon;
export declare const PolygonFromCircle: (center: CanvasJpPoint, radius: number, numberOfEdges: number, phase?: number) => CanvasJpPolygon;
export declare const polygonArea: ({ points, }: {
    points: CanvasJpPoint[];
}) => number;
export declare const polygonCenter: (polygon: CanvasJpPolygon) => CanvasJpWeightedPoint;
export declare const polygonLines: (polygon: CanvasJpPolygon, stroke: CanvasJpStroke) => CanvasJpSharpLine[];
export declare const isInPolygon: (polygon: CanvasJpPolygon, point: CanvasJpPoint) => boolean;
export declare const sampleInPolygon: (polygon: CanvasJpPolygon) => CanvasJpWeightedPoint;
