export declare enum CanvasJpShaderType {
    "fragment" = "fragment",
    "vertex" = "vertex"
}
export declare type CanvasJpShaderUniform = {
    name: string;
    type: "vec2";
    value: [number, number];
} | {
    name: string;
    type: "vec4";
    value: [number, number, number, number];
} | {
    name: string;
    type: "float[]";
    value: number[];
} | {
    name: string;
    type: "float";
    value: number;
} | {
    name: string;
    type: "texture";
    value: TexImageSource;
};
export declare type CanvasJpShaderOptions = {
    uniforms: CanvasJpShaderUniform[];
};
export declare type CanvasJpShader = {
    __type: "Shader";
    type: CanvasJpShaderType;
    source: string;
    options?: CanvasJpShaderOptions;
    compositeOperation?: GlobalCompositeOperation;
};
export declare const Shader: (type: CanvasJpShaderType, source: string, options?: CanvasJpShaderOptions | undefined, compositeOperation?: GlobalCompositeOperation | undefined) => CanvasJpShader;
