import { CanvasJpTranslate } from "./transform";
import { CanvasJpColorHsv, CanvasJpGradient, CanvasJpRadialGradient } from "./Color";
import { CanvasJpSharpShape, CanvasJpSmoothShape } from "./Shape";
import { CanvasJpArc } from "./Circle";
import { CanvasJpSharpLine, CanvasJpSmoothLine } from "./Line";
import { CanvasJpClip } from "./Clip";
import { CanvasJpClickRegion, CanvasJpRenderOnlyWhenVisible } from "./interaction";
import { CanvasJpSeed } from "./Seed";
import { CanvasJpRandom } from ".";
import { CanvasJpOverlay } from "./Overlay";
import { CanvasJpUpdateImageData } from "./UpdateImageData";
import { CanvasJpShader } from "./Shader";
export declare type CanvasJpFill = {
    color: CanvasJpColorHsv | CanvasJpGradient | CanvasJpRadialGradient;
    opacity: number;
    compositionOperation?: GlobalCompositeOperation;
    filter?: string;
};
export declare enum CanvasJpStrokeStyle {
    "round" = "round",
    "square" = "square"
}
export declare type CanvasJpStroke = {
    color: CanvasJpColorHsv | CanvasJpGradient;
    opacity: number;
    style?: CanvasJpStrokeStyle;
    width: number;
};
export declare type CanvasJpDrawable = CanvasJpSharpShape | CanvasJpSmoothShape | CanvasJpArc | CanvasJpSharpLine | CanvasJpSmoothLine | CanvasJpClip | CanvasJpTranslate | CanvasJpClickRegion | CanvasJpRenderOnlyWhenVisible | CanvasJpSeed | CanvasJpOverlay | CanvasJpUpdateImageData | CanvasJpShader;
export declare type CanvasJpFrameDefinition = {
    background?: CanvasJpColorHsv;
    border?: CanvasJpStroke;
    elements: CanvasJpDrawable[];
    shader?: CanvasJpShader;
};
export declare const draw: (ctx: CanvasRenderingContext2D, { background, border, elements }: CanvasJpFrameDefinition, { width, height, resolution, pixelDensity, setSeed, }: {
    width: number;
    height: number;
    resolution: number;
    pixelDensity: number;
    setSeed: (id: number) => {
        random: CanvasJpRandom;
        reset: () => void;
    };
}, svgContainer: HTMLElement | null, { shouldTick, addCanvas, setCanvasSize, }: {
    shouldTick?: boolean | undefined;
    addCanvas: (canvas: HTMLCanvasElement) => void;
    setCanvasSize: (canvas: HTMLCanvasElement) => void;
}) => Promise<(() => void)[]>;
