import { CanvasJpFrameDefinition, CanvasJpDrawable, CanvasJpStrokeStyle } from "./draw";
export declare type CanvasJpPlugin = (executeCanvasJp: CanvasJpExecuteCanvas, container: HTMLElement) => CanvasJpExecuteCanvas;
declare type CanvasJpOptions = {
    width: number;
    height: number;
    resolution: number;
    interactive: boolean;
    plugins?: CanvasJpPlugin[];
};
export declare type CanvasJpRandom = {
    getSeed: () => number;
    setSeed: (seed: number) => void;
    value: () => number;
    shuffle: <T>(array: Array<T>) => Array<T>;
    pick: <T>(array: Array<T>) => T;
    gaussian: (mean: number, standardDerivation: number) => number;
    onSphere: (radius?: number) => [number, number, number];
    noise1D: (x: number, frequency?: number, amplitude?: number) => number;
    noise2D: (x: number, y: number, frequency?: number, amplitude?: number) => number;
    noise3D: (x: number, y: number, z: number, frequency?: number, amplitude?: number) => number;
};
declare type CanvasJpDestroy = () => void;
export declare type CanvasJpExecuteCanvas = (initialSeed?: number | string) => Promise<CanvasJpDestroy>;
export declare function canvasJp(container: HTMLElement, frameDefinition: (random: CanvasJpRandom, options: {
    width: number;
    height: number;
    resolution: number;
}) => Generator<CanvasJpFrameDefinition | Promise<CanvasJpFrameDefinition> | void | Promise<void>>, options: CanvasJpOptions | (() => CanvasJpOptions)): Promise<CanvasJpDestroy>;
export { CanvasJpFrameDefinition, CanvasJpDrawable, CanvasJpOptions, CanvasJpStrokeStyle, };
